{
Perkelimai:
  Atsargos[2]       - Atsarg sskaitos (2)
  Atsargu_suma[2]   - Atsarg suma

  Zaliavos[2]       - aliav sskaitos (2)
  Zaliavu_suma[2]   - aliav suma

  Produkcija[2]       - Produkcijos sskaitos (2)
  Produkcijos_suma[2] - Produkcijos suma

Pastaba:
 1) Atsargos ir atsarg suma tai tas pats kas aliavos ir aliav suma.
 2) aliav suma yra tokia pati kaip ir produkcijos suma

  -----------------------------|-----------------------------|----------------------------
  Debetas                      | Kreditas                    | suma
  -----------------------------|-----------------------------|----------------------------
  (2) Tarpine                  | (2) Zaliavos                | Zaliavos_suma
  (2) Produkcija               | (2) Tarpine                 | Produkcijos_suma

}
{
Rezultatas:
   [x]     - grup
   [x+1]   - debetas
   [x+2]   - kreditas
   [x+3]   - suma
}

const
  TarpineSaskaita = '20120'; 	// Atsargos / nebaigta gamyba / sigijimo savikaina

function Operacija(
  Data: TDateTime;
  Kintamieji: Variant; // kintamieji: VarArray [0..N] of String
  Value: Variant       // reikms: VarArray [0..N] of variant
  ): Variant;

var
  rez: Variant;

  Zaliavu_suma: Variant;
  Produkcijos_suma: Variant;

  Zaliavos: Variant;
  Produkcija: Variant;

  iIndex: integer;
  i1: integer;
  i2: integer;
  i: integer;

  v: Variant;

  function Rasti(Kas: String): Variant;
  var
    i: integer;
  begin
    Result := Unassigned;
    for i := VarArrayLowBound(Kintamieji,1) to VarArrayHighBound(Kintamieji,1) do begin
      if Uppercase(Kas) = Uppercase(Kintamieji[i]) then begin
        Result := Value[i];
        Exit;
      end;
    end;
    ShowMessage(Kas + ' = Unassigned');
  end;

  procedure VarToVarArray(var v:variant);
  var
    vTmp: variant;
  begin
    if (VarType(v) and varArray) = 0 then begin
      vTmp := v;
      v := VarArrayCreate([0,0], varVariant);
      v[0] := vTmp;
    end;
  end;

begin
  Zaliavu_suma :=  Rasti('Zaliavu_suma');
  Produkcijos_suma := Rasti('Produkcijos_suma');

  VarToVarArray(Zaliavu_suma);
  VarToVarArray(Produkcijos_suma);

  Zaliavos := Rasti('Zaliavos');
  Produkcija := Rasti('Produkcija');

  VarToVarArray(Zaliavos);
  VarToVarArray(Produkcija);

  i1 := VarArrayHighBound(Zaliavos,1)-VarArrayLowBound(Zaliavos,1)+1;
  i2 := VarArrayHighBound(Produkcija,1)-VarArrayLowBound(Produkcija,1)+1;

  rez := VarArrayCreate([0,(i1+i2)*4-1], varVariant);

  iIndex := 0;
  // Debetas                      | Kreditas                    | suma
  // -----------------------------|-----------------------------|----------------------------
  // (2) Tarpine                  | (2) Zaliavos                | Zaliavos_suma
  for i := 0 to i1-1 do begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := TarpineSaskaita;   // debetas
    rez[iIndex+2] := Zaliavos[i];       // kreditas
    rez[iIndex+3] := Zaliavu_suma[i];
    iIndex := iIndex + 4;
  end;
  // (2) Produkcija               | (2) Tarpine                 | Produkcijos_suma
  for i := 0 to i2-1 do begin
    rez[iIndex+0] := 2;
    rez[iIndex+1] := Produkcija[i];     // debetas
    rez[iIndex+2] := TarpineSaskaita;   // kreditas
    rez[iIndex+3] := Produkcijos_suma[i];
    iIndex := iIndex + 4;
  end;

  Result := rez;
end;

begin
end.

