﻿{ 2012-03-02
Pirkimo grąžinimas:
  Tiekejas          - Tiekejo sąskaitos (22/45)
  Moketinas_PVM     - Moketino PVM sąskaita (4701)
  Gautinas_PVM      - Gautino PVM sąskaita (251)

  Suma_be_PVM       - suma be PVM
  PVM_suma          - PVM suma
  Suma              - viso suma su PVM

  Atsargos[1]       - Atsargų sąskaitos (2)
  Atsargu_suma[1]   - Atsargų suma

  Sanaudos[2],
  Savikaina[2]      - Sąnaudų/savikainos sąskaitos (6)
  Sanaudu_suma[2],
  Savikainos_suma[2] - Sąnaudų/savikainos suma

  -----------------------------|-----------------------------|----------------------------
  Debetas                      | Kreditas                    | suma
  -----------------------------|-----------------------------|----------------------------
  (22/45) Tiekejas             | (251) Gautinas_PVM          | PVM_suma
  (22/45) Tiekejas             | (2) Atsargos [1]            | Atsargu_suma [1]

  --nereikia!!!
  (22/45) Tiekejas             | (6) Sanaudos [2]            | Sanaudu_suma [2]

  viso įrašu: 1 + [1]
}
{
Rezultatas:
   [x]     - grupė
   [x+1]   - debetas
   [x+2]   - kreditas
   [x+3]   - suma
}

function Operacija(
  Data: TDateTime;
  Kintamieji: Variant; // kintamieji: VarArray [0..N] of String
  Value: Variant       // reikšmės: VarArray [0..N] of variant
  ): Variant;

var
  rez: Variant;

  Suma_be_PVM: currency;
  PVM_suma: currency;
  Suma: currency;

  Savikainos_suma: Variant;
  Sanaudu_suma: Variant;
  Atsargu_suma: Variant;

  Sanaudos: Variant;
  Savikaina: Variant;
  Atsargos: Variant;

  Tiekejas: string;
  Gautinas_PVM: string;
  Moketinas_PVM: string;

  iIndex: integer;
  i1: integer;
  i2: integer;
  i: integer;

  v: Variant;

  function Rasti(Kas: String): Variant;
  var
    i: integer;
  begin
    Result := Unassigned;
    for i := VarArrayLowBound(Kintamieji,1) to VarArrayHighBound(Kintamieji,1) do begin
      if Uppercase(Kas) = Uppercase(Kintamieji[i]) then begin
        Result := Value[i];
        Exit;
      end;
    end;
    ShowMessage(Kas + ' = Unassigned');
  end;

  procedure VarToVarArray(var v:variant);
  var
    vTmp: variant;
  begin
    if (VarType(v) and varArray) = 0 then begin
      vTmp := v;
      v := VarArrayCreate([0,0], varVariant);
      v[0] := vTmp;
    end;
  end;

begin
  Suma_be_PVM := Rasti('Suma_be_PVM');
  PVM_suma := Rasti('PVM_suma');
  Suma := Rasti('Suma');

  Savikainos_suma := Rasti('Savikainos_suma');
  Sanaudu_suma := Rasti('Sanaudu_suma');
  Atsargu_suma := Rasti('Atsargu_suma');

  VarToVarArray(Savikainos_suma);
  VarToVarArray(Sanaudu_suma);
  VarToVarArray(Atsargu_suma);

  Sanaudos := Rasti('Sanaudos');
  Savikaina := Rasti('Savikaina');
  Atsargos := Rasti('Atsargos');

  VarToVarArray(Sanaudos);
  VarToVarArray(Savikaina);
  VarToVarArray(Atsargos);

  i1 := VarArrayHighBound(Atsargos,1)-VarArrayLowBound(Atsargos,1)+1;
  //i2 := VarArrayHighBound(Sanaudos,1)-VarArrayLowBound(Sanaudos,1)+1;

  Tiekejas := Rasti('Tiekejas');
  Moketinas_PVM := Rasti('Moketinas_PVM');
  Gautinas_PVM := Rasti('Gautinas_PVM');

  rez := VarArrayCreate([0,(1+i1+i2)*4-1], varVariant);

  iIndex := 0;
  // Debetas                      | Kreditas                    | suma
  // -----------------------------|-----------------------------|----------------------------
  // (22/45) Tiekejas             | (251) Gautinas_PVM          | PVM_suma
  if PVM_suma > 0 then begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := Tiekejas;      // debetas
    rez[iIndex+2] := Gautinas_PVM;  // kreditas
    rez[iIndex+3] := PVM_suma;
    iIndex := iIndex + 4;
  end;
  // (22/45) Tiekejas             | (2) Atsargos [1]            | Atsargu_suma [1]
  for i := 0 to i1-1 do begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := Tiekejas;      // debetas
    rez[iIndex+2] := Atsargos[i];   // kreditas
    rez[iIndex+3] := Atsargu_suma[i];
    iIndex := iIndex + 4;
  end;
  // (22/45) Tiekejas             | (6) Sanaudos [2]            | Sanaudu_suma [2]
  //for i := 0 to i2-1 do begin
  //  rez[iIndex+0] := 1;
  //  rez[iIndex+1] := Tiekejas;      // debetas
  //  rez[iIndex+2] := Sanaudos[i];   // kreditas
  //  rez[iIndex+3] := Sanaudu_suma[i];
  //  iIndex := iIndex + 4;
  //end;

  Result := rez;
end;

begin
end.
