{
Banko kitos operacijos:
  BalansineSaskaita - balansin sskaita
  Bankas       - Banko sskaita
  Suma         - suma

  jei Suma > 0
  -----------------------------|-----------------------------|----------------------------
  Debetas                      | Kreditas                    | suma
  -----------------------------|-----------------------------|----------------------------
  Bankas                       | BalansineSaskaita           | Suma

  jei Suma < 0
  -----------------------------|-----------------------------|----------------------------
  Debetas                      | Kreditas                    | suma
  -----------------------------|-----------------------------|----------------------------
  BalansineSaskaita            | Bankas                      | Suma
}
{
Rezultatas:
   [x]     - grup
   [x+1]   - debetas
   [x+2]   - kreditas
   [x+3]   - suma
}

function Operacija(
  Data: TDateTime;
  Kintamieji: Variant; // kintamieji: VarArray [0..N] of String
  Value: Variant       // reikms: VarArray [0..N] of variant
  ): Variant;

var
  rez: Variant;
  Suma: currency;
  Bankas: string;
  BalansineSaskaita: string;

  function Rasti(Kas: String): Variant;
  var
    i: integer;
  begin
    Result := Unassigned;
    for i:=VarArrayLowBound(Kintamieji,1) to VarArrayHighBound(Kintamieji,1) do begin
      if Uppercase(Kas) = Uppercase(Kintamieji[i]) then begin
        Result := Value[i];
        Break;
      end;
    end;
  end;

begin
  Suma := Rasti('Suma');
  Bankas := Rasti('Bankas');
  BalansineSaskaita := Rasti('BalansineSaskaita');
  //ShowMessage('Suma='+VarToStr(Suma)+' '
  //  +'Bankas='+VarToStr(Bankas)+' '
  //  +'BalansineSaskaita='+VarToStr(BalansineSaskaita));
  if Suma > 0 then begin
    rez := VarArrayCreate([0,3], varVariant);
    rez[0] := 1;
    rez[1] := Bankas;    // debetas
    rez[2] := BalansineSaskaita;  // kreditas
    rez[3] := Suma;
    Result := rez;
  end else begin
    rez := VarArrayCreate([0,3], varVariant);
    rez[0] := 1;
    rez[1] := BalansineSaskaita;    // debetas
    rez[2] := Bankas;  // kreditas
    rez[3] := -Suma;
    Result := rez;
  end
end;

begin
end.


