{
Skol likuio inventorizacija:
  BalansineSaskaita - Balansine saskaita
  Debetas[1]      - Debeto saskaitos
  Debeto_suma[1]  - Debeto sumos
  Kreditas[2]     - Kredito saskaitos
  Kredito_suma[2] - Kredito sumos

  -----------------------------|-----------------------------|----------------------------
  Debetas                      | Kreditas                    | suma
  -----------------------------|-----------------------------|----------------------------
  Debetas[1]                   | BalansineSaskaita           | Debeto_suma[1]
  BalansineSaskaita            | Kreditas[2]                 | Kredito_suma[2]
}
{
Rezultatas:
   [x]     - grup
   [x+1]   - debetas
   [x+2]   - kreditas
   [x+3]   - suma
}

function Operacija(
  Data: TDateTime;
  Kintamieji: Variant; // kintamieji: VarArray [0..N] of String
  Value: Variant       // reikms: VarArray [0..N] of variant
  ): Variant;

var
  rez: Variant;
  BalansineSaskaita: string;
  Debetas: Variant;
  Debeto_suma: Variant;
  Kreditas: Variant;
  Kredito_suma: Variant;

  iIndex: integer;
  i1: integer;
  i2: integer;
  i: integer;


  function Rasti(Kas: String): Variant;
  var
    i: integer;
  begin
    Result := Unassigned;
    for i:=VarArrayLowBound(Kintamieji,1) to VarArrayHighBound(Kintamieji,1) do begin
      if Uppercase(Kas) = Uppercase(Kintamieji[i]) then begin
        Result := Value[i];
        Break;
      end;
    end;
  end;

  procedure VarToVarArray(var v:variant);
  var
    vTmp: variant;
  begin
    if (VarType(v) and varArray) = 0 then begin
      vTmp := v;
      v := VarArrayCreate([0,0], varVariant);
      v[0] := vTmp;
    end;
  end;

begin
  Debetas := Rasti('Debetas');
  Debeto_suma := Rasti('Debeto_suma');
  Kreditas := Rasti('Kreditas');
  Kredito_suma := Rasti('Kredito_suma');
  BalansineSaskaita := Rasti('BalansineSaskaita');

  VarToVarArray(Debetas);
  VarToVarArray(Debeto_suma);
  VarToVarArray(Kreditas);
  VarToVarArray(Kredito_suma);

  i1 := VarArrayHighBound(Debetas,1)-VarArrayLowBound(Debetas,1)+1;
  i2 := VarArrayHighBound(Kreditas,1)-VarArrayLowBound(Kreditas,1)+1;

  rez := VarArrayCreate([0,(1+i1+i2)*4-1], varVariant);
  iIndex := 0;
  for i := 0 to i1-1 do begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := Debetas[i];    // debetas
    rez[iIndex+2] := BalansineSaskaita;  // kreditas
    rez[iIndex+3] := Debeto_suma[i];
    iIndex := iIndex + 4;
  end;
  for i := 0 to i2-1 do begin
    rez[iIndex+0] := 2;
    rez[iIndex+1] := BalansineSaskaita;    // debetas
    rez[iIndex+2] := Kreditas[i];  // kreditas
    rez[iIndex+3] := Kredito_suma[i];
    iIndex := iIndex + 4;
  end;
  Result := rez;
end;

begin
end.


